	/* @FILE_NAME@.c:  template for map */
	/* map performed by hashtable */
#if       !defined(@PKG_CAP_NAME@_USE_LIST)  && \
	  !defined(@PKG_CAP_NAME@_USE_HASH)  && \
	  !defined(@PKG_CAP_NAME@_USE_BINTREE) && \
	  !defined(@PKG_CAP_NAME@_USE_AVLTREE)
	/* default implementation */
#define @PKG_CAP_NAME@_USE_@IMPL_CAP_NAME@
#endif /* !defined(@PKG_CAP_NAME@_USE_LIST)  && 
	  !defined(@PKG_CAP_NAME@_USE_HASH)  && 
	  !defined(@PKG_CAP_NAME@_USE_BINTREE) && 
	  !defined(@PKG_CAP_NAME@_USE_AVLTREE) */

#define PKG_NAME_(x)	    	@PKG_NAME@_impl_##x
#define PKG_NAME_STRING	 	"@PKG_NAME@_impl"
#define PKG_MAPKEY_T          	@KEY_TYPE@
#define PKG_MAPVAL_T          	@VALUE_TYPE@
#define PKG_USE_STATIC

#if   defined(@PKG_CAP_NAME@_USE_HASH)
#   include <ctmpl/hashtable.h>
#   include <ctmpl/hashtable.c>
typedef PKG_NAME_(ht) 			@PKG_NAME@;
typedef PKG_NAME_(ht_iterator) 		@PKG_NAME@_iterator;
typedef PKG_NAME_(ht_iterator_data) 	@PKG_NAME@_iterator_data;
#define @PKG_NAME@_new(x, y, z, a, b)         \
        @PKG_NAME@_impl_ht_new_by(x, y, z, a, b)

	/* map performed by sorted list */
#elif defined(@PKG_CAP_NAME@_USE_LIST)
#   include <ctmpl/slist_map.h>
#   include <ctmpl/slist_map.c>
typedef PKG_NAME_(slm) 			@PKG_NAME@;
typedef PKG_NAME_(slm_iterator) 	@PKG_NAME@_iterator;
typedef PKG_NAME_(slm_iterator_data) 	@PKG_NAME@_iterator_data;
#define @PKG_NAME@_new(x, y, z, a, b)         \
        @PKG_NAME@_impl_slm_new_by(z, a, b)

	/* map performed by binary tree */
#elif defined(@PKG_CAP_NAME@_USE_BINTREE)
#   include <ctmpl/bintree.h>
#   include <ctmpl/bintree.c>
typedef PKG_NAME_(bt) 			@PKG_NAME@;
typedef PKG_NAME_(bt_iterator) 		@PKG_NAME@_iterator;
typedef PKG_NAME_(bt_iterator_data) 	@PKG_NAME@_iterator_data;
#define @PKG_NAME@_new(x, y, z, a, b)         \
        @PKG_NAME@_impl_bt_new_by(z, a, b)

	/* map performed by AVL binary tree */
#elif defined(@PKG_CAP_NAME@_USE_AVLTREE)
#   include <ctmpl/avltree.h>
#   include <ctmpl/avltree.c>
typedef PKG_NAME_(avt) 			@PKG_NAME@;
typedef PKG_NAME_(avt_iterator) 	@PKG_NAME@_iterator;
typedef PKG_NAME_(avt_iterator_data) 	@PKG_NAME@_iterator_data;
#define @PKG_NAME@_new(x, y, z, a, b)         \
        @PKG_NAME@_impl_avt_new_by(z, a, b)
#else
# error "not-supported implementation"
#endif /* defined(@PKG_CAP_NAME@_USE_XXXX) */

#undef PKG_NAME_
#undef PKG_NAME_STRING
#undef PKG_MAPKEY_T
#undef PKG_MAPVAL_T
#undef PKG_USE_STATIC

