/*
 *			memory.h
 * $Id: memory.h,v 1.1 2004/01/14 16:05:15 hiddy Exp $
 * Copyright (C) 2003 Hideaki Imaizumi <hiddy@sfc.wide.ad.jp>
 *               All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _MALLOC_H_
#define _MALLOC_H_

/* memory debugger */
#define MALLOC(x, y)	xw_malloc(x, y, __FILE__, __LINE__)
#define FREE(x, y)   	xw_free(x, y, __FILE__, __LINE__)
extern void *(*xw_malloc)(const char *, size_t, const char *, int);
extern void (*xw_free)(const char *, void *, const char *, int);
#endif /* _MALLOC_H_ */

