        /* @FILE_NAME@.h:  template for sequence */
#ifndef _@PKG_CAP_NAME@_@FILE_CAP_NAME@_H_
#define _@PKG_CAP_NAME@_@FILE_CAP_NAME@_H_

#if !defined(@PKG_CAP_NAME@_USE_LIST)  && \
    !defined(@PKG_CAP_NAME@_USE_VECTOR) 
	/* default implementation */
#define @PKG_CAP_NAME@_USE_@IMPL_CAP_NAME@
#endif /* !defined(@PKG_CAP_NAME@_USE_LIST)  && 
    	  !defined(@PKG_CAP_NAME@_USE_VECTOR) */

#define PKG_NAME_(x)            @PKG_NAME@_impl_##x
#define PKG_NAME_STRING         "@PKG_NAME@_impl"
#define PKG_SEQVAL_T        	@VALUE_TYPE@

#if defined(@PKG_CAP_NAME@_USE_LIST)
#   include <ctmpl/list.h>	/* by list */
typedef PKG_NAME_(list) 		@PKG_NAME@;
typedef PKG_NAME_(list_iterator) 	@PKG_NAME@_iterator;
typedef PKG_NAME_(listdata_t) 		@PKG_NAME@_iterator_data;
#define @PKG_NAME@_new(x, y, a, b)	@PKG_NAME@_impl_list_new_by(a, b)

#elif defined(@PKG_CAP_NAME@_USE_VECTOR)
#   include <ctmpl/vector.h>	/* by vector */
typedef PKG_NAME_(vector) 		@PKG_NAME@;
typedef PKG_NAME_(vector_iterator) 	@PKG_NAME@_iterator;
typedef PKG_NAME_(vecdata_t) 		@PKG_NAME@_iterator_data;
#define @PKG_NAME@_new(x, y, a, b)	@PKG_NAME@_impl_vector_new_by(x, y, a, b)
#else
# error "not-supported implementation"
#endif /* defined(USE_XXXX) */

#undef PKG_NAME_
#undef PKG_NAME_STRING
#undef PKG_SEQVAL_T

#endif /*_@PKG_CAP_NAME@_@FILE_CAP_NAME@_H_ */
